local mod = RW:Boss("Yogg-Saron", "Ulduar", "Ulduar")
local L

---------------------------
-- Variables
local tBerserk
local tSpeedKill
local mPhase
-- Phase 1
local wSarasFervor, iSarasFervor
local mGuardianSpawn
-- Phase 2
local tMaladyCast, wMalady, wMaladyLink, iMalady
local wMaladyclose
local wSqueeze, iSqueeze
local tNextPortals, wPortalsSoon, tInduceMadness, wInduceMadness
local wBrainLink, iBrainLink
-- Phase 3
local tDeafeningRoarCast, tDeafeningRoarCD
local tLunaticGazeDur, tLunaticGazeCD
local tShadowBeaconCD, tShadowBeaconDur, wShadowBeacon
local tEmpoweringShadowsDur
local wDeafeningRoar

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Yogg-Saron"
		
		L.YellPull = "The time to strike at the head of the beast will soon be upon us! Focus your anger and hatred on his minions!"
		L.YellDeath = "Your fate is sealed. The end of days is finally upon you and ALL who inhabit this miserable little seedling. Uulwi ifis halahs gag erh'ongg w'ssh."
		L.YellPhase2 = "I am the lucid dream."
		L.YellPhase3 = "Look upon the true face of death and know that your end comes soon!"
		
		L.Madness_msg = "Get out!"
		L.Madness_opt = "Induce Madness 5sec warning"
		L.Maladyclose_msg = "Malady close!!!"
		L.Maladyclose_opt = "Malady close warning"
		
		L.Portals_timer = "Next portals"
		L.Portalssoon_msg = "Portals soon!"
		L.Portalssoon_opt = "Portals soon warning"
		L.Portals_opt = "Portal bar and warning"

	end

	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(L.YellPull, 33288)
	self:SetWin(L.YellDeath, 33288)
	
	--self:AddToCategory("Phase 1", "Phase 2", "Phase 3")
	self:AddToCategory("Phase 1", 63138, 62979)
	self:AddToCategory("Phase 2", 64059, 63830, 64126, 63802, L.Portals_opt, L.Maladyclose_opt)
	--self:AddGeneralOption(L.Portals_opt, "Phase 2", select(3, GetSpellInfo(49361)))
	--self:AddGeneralOption(L.Maladyclose_opt, "Phase 2", select(3, GetSpellInfo(63830)))
	self:AddToCategory("Phase 3", 64189, 64465, 64163, 64468)
	
	tBerserk = self:BerserkTimer(900)
	tSpeedKill = self:AchievementTimer(420, 3012)
	
	mPhase	= self:PhaseMessage()
	
-- Phase 1
	wSarasFervor  	= self:CastWarning(63138)
	iSarasFervor 	= self:Icon("SKULL", 63138, false, 15, "CROSS", "SQUARE")
	mGuardianSpawn 	= self:CastMessage(62979)
	
-- Phase 2
	tInduceMadness  = self:CastTimer(64059)
	tNextPortals	= self:CustomTimer(27, L.Portals_timer, L.Portals_timer, 49361, L.Portals_opt)
	tMaladyCast		= self:CastTimer(63830)
	
	wMalady			= self:CastWarning(63830)
	wMaladyclose	= self:CustomWarning(L.Maladyclose_msg, L.Maladyclose_opt, 63830, L.Maladyclose_opt, true, nil, "RW: RunAwayLittleGirl")
	wSqueeze		= self:CastWarning(64126)
	wPortalsSoon    = self:CustomWarning(L.Portalssoon_msg, L.Portalssoon_opt, 49361, L.Portals_opt)
	wInduceMadness  = self:CustomWarning(L.Madness_msg, L.Madness_opt, 64059)
	wBrainLink		= self:CastWarning(63802)
	
	iMalady			= self:Icon("SKULL", 63830, false, 4)
	iSqueeze		= self:Icon("CROSS", 64126, false, 20, "CIRCLE")
	iBrainLink		= self:Icon("DIAMOND", 63802, false, 30, "TRIANGLE", "MOON", "SQUARE")
	
-- Phase 3
	wDeafeningRoar		= self:CastWarning(64189)
	
	wShadowBeacon 		= self:CastWarning(64465)
	
	tDeafeningRoarCast	= self:CastTimer(64189) 
	tDeafeningRoarCD	= self:CDTimer(57.7, 64189)
	tLunaticGazeDur		= self:DurTimer(4, 64163)
	tLunaticGazeCD		= self:CDTimer(5, 64163)
	tShadowBeaconCD		= self:CDTimer(35, 64465)
	tShadowBeaconDur	= self:DurTimer(10, 64465) 
	tEmpoweringShadowsDur = self:DurTimer(20, 64468)
end

---------------------------
-- Locals
local guardianCount
local empShadows
local sBeacon
local phase

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("SarasFervor", 63138)
	self:Track("GuardianSpawn", 62979)
	
	self:YellTrack("Phase2", L.YellPhase2)
	self:Track("Malady", 63830, 63881)
	self:Track("Squeeze", 64125, 64126)
	self:Track("InduceMadness", 64059)
	self:Track("BrainLink", 63802)
	
	self:YellTrack("Phase3", L.YellPhase3)
	self:Track("DeafeningRoar", 64189)
	self:Track("LunaticGaze", 64163)
	self:Track("ShadowBeacon", 64465)
	self:Track("EmpoweringShadows", 64468, 64486)
	
	guardianCount = 0
	empShadows = false
	sBeacon = false
	tBerserk:Start()
	tSpeedKill:Start()
	self:SendMessage("RW_AddHealthFrame", 33134)
end

----------------- Phase 1
function mod:SarasFervor(event, args)
	if event == "SPELL_AURA_APPLIED" then
	 	iSarasFervor:Show(args.dName)
		if args:IsPlayer() then
			wSarasFervor:Show()
		end
	end
end

function mod:GuardianSpawn(event, args)
	if event == "SPELL_SUMMON" then
		guardianCount = guardianCount +1
		mGuardianSpawn:Show(guardianCount)
	end
end

----------------- Phase 2
function mod:Phase2(event, msg, name)
	self:SendMessage("RW_RemoveAllHealthFrames")
	mPhase:Show(2)
	tNextPortals:Start(70)
	wPortalsSoon:Schedule(60)
end	

function mod:Malady(event, args)
	if event == "SPELL_CAST_START" then
		tMaladyCast:Start()
		wMalady:Show()
		
	elseif event == "SPELL_AURA_APPLIED" then
		iMalady:Show(args.dName)
		if self.Party.group[name] then
			uID = self.Party.group[args.dName].id
			if uID and CheckInteractDistance(uID, 2) then
				wMaladyclose:Show()
			end
		end
	end
end

function mod:Squeeze(event, args)
	if event == "SPELL_AURA_APPLIED" then
		wSqueeze:Show(args.dName)
		iSqueeze:Show(args.dName)
		if args:IsPlayer() then
			SendChatMessage("I'm getting squeezed!", "SAY")
		end
	end
	if event == "SPELL_AURA_REMOVED" then
		iSqueeze:Hide(args.dName)
	end
end

function mod:InduceMadness(event, args)
	if event == "SPELL_CAST_START" then
		tInduceMadness:Start()
		wInduceMadness:Schedule(53)
		tNextPortals:Schedule(60)
		wPortalsSoon:Schedule(77)
	end
end

function mod:BrainLink(event, args)
	if event == "SPELL_AURA_APPLIED" then
		iBrainLink:Show(args.dName)
		if args:IsPlayer() then
			wBrainLink:Show()
		end
	end
end

----------------- Phase 3
function mod:Phase3(event, msg, name)
	mPhase:Show(3)
	tNextPortals:Stop()
	tInduceMadness:Stop()
	wPortalsSoon:Unschedule()
end	

function mod:DeafeningRoar(event, args)
	if event == "SPELL_CAST_START" then
		tDeafeningRoarCast:Start()
		tDeafeningRoarCD:Schedule(2.2)
		wDeafeningRoar:Show()
	end
end

function mod:LunaticGaze(event, args)
	if event == "SPELL_CAST_START" then
		tLunaticGazeDur:Start()
		tLunaticGazeCD:Schedule(4)
	end
end

local function BeaconCheck()
	sBeacon = false
end

function mod:ShadowBeacon(event, args)
	if event == "SPELL_AURA_APPLIED" and sBeacon == false then
		tShadowBeaconDur:Start() 
		wShadowBeacon:Show()
		sBeacon = true
		self:Schedule("BeaconCheck", 5, BeaconCheck)
	end
	if event == "SPELL_AURA_REMOVED" then
		tShadowBeaconCD:Start()
	end
end

local function EmpoweringCheck()
	empShadows = false
end

function mod:EmpoweringShadows(event, args)
	if event == "SPELL_AURA_APPLIED" and empShadows == false then
		tEmpoweringShadowsDur:Start()
	end
	empShadows = true
	self:Schedule("EmpoweringCheck", 5, EmpoweringCheck)
end